/**
***     textctlapp.cpp
***
***     ̃\[XR[h́AG[TXyhAW[Ȃǂ̏ȗĂ܂B
***     Copyright (C) 2002 - 2008 Sophia Cradle Incorporated
***     All rights reserved.
***
**/

#include "textctlapp.hpp"

#define TROPICALBLUE_COLOR  (SFXRGBColor(0xB6, 0xCE, 0xF6, 0x00))
#define SELAGO_COLOR        (SFXRGBColor(0xF7, 0xE8, 0xFD, 0x00))

//
//  u[g [_(BREW Avbg̋NR[h)F
//  BREW Avbg[hƁAԍŏɂ̊֐Ă΂
//  nꂽ ClassID  ̃Avbg ClassID ɓꍇA
//  AvP[VNX̃CX^X쐬֐Ԃ
//
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    *license = "heap://RCVHT2R2Z2UOWKS6YFXNZ3RISIZ2Y8U7S5XASBT3YQY5VOSCWBCVIR6V1VGT8YQY9U"
        "LVOVJYCY4VP1Z84SQ1TCSJTAWJR9XNV8SPX8S6S4UOXEWAY1XDX9ULUNY7W7WGU7T5U9VQ6Z1NW6VKU3"
        "KXGR6RNIY1VAVJWGTNYHRH6RIU1Y9UDSMT0JS3SCUAW4Z0LWPJRBU4SFYAUDRCNT1TKU7TQXPUPW3RGX"
        "3UPSCR5Y6TFZ8VLVQU1UQR0U6S0VO94UBVORJTFOWKSITBSJZ8R7U8SLS8SJY4X8TAWLSAR8WIUPYIYI"
        "UHSCROY0UFS8XGSIV5WLUMR9U7SOSMVKWBY1TQYEVQS1RKW3VAW2W2V5S3Y4SL/";

    return (id == AEECLSID_TEXTCTLAPP) ? (&textctlapp::Factory) : (null);
}

//
// t@Ng֐
//
SFCInvokerPtr textctlapp::Factory(Void)
{
    return ::new textctlapp; // textctlapp AvP[VNX̃CX^X𐶐
}

//
// RXgN^
//
textctlapp::textctlapp(Void) static_throws
{
    SFCError error(SFERR_NO_ERROR);

    if (static_try()) {
        // t[𐶐
        _frame = SFZTitleBevelFrame::NewInstance(&error);
        if (error == SFERR_NO_ERROR) {
            _frame->SetParent(GetRoot());            // [geɂ
            _frame->SetRealBound(GetLocalBound());   // ̈ݒ肷i[g̗̈Ɠj
            _frame->SetState(true, true, true,true); // Ԃ܂Ƃ߂āu{{\{tH[JXvɂ
            _frame->ToFront();                       // őOʂɈړ
            _frame->SetText("textctlapp");           // t[̃^Cg "textctlapp" ɐݒ肷

            // EBhE𐶐
            _window = SFZWindow::NewInstance(&error);
            if (error == SFERR_NO_ERROR) {
                _window->SetParent(_frame);                      // t[eɂ
                _window->SetBackgroundColor(TROPICALBLUE_COLOR); // wi Tropical Blue Fœhׂ
                _window->SetRealBound(_frame->GetLocalBound().Deflate(_frame->GetSuitableMargin())); // ̈ݒ肷
                _window->SetState(true,true,true,true);          // Ԃ܂Ƃ߂āu{{\{tH[JXvɂ
                _window->ToFront();                              // őOʂɈړ

                SFXRectangle rect = _window->GetLocalBound().Deflate(10, 10); // GfBbg{bNXA{^Axzu`̈
                SInt16 h = rect.GetHeight()/3;                                // GfBbg{bNXA{^Axe`̈̍
                SFXRectangle rect_base = rect.SetHeight(h);                   // GfBbg{bNXzu`̈

                // GfBbg{bNX𐶐
                _editbox =SFZSingleEditBoxControl::NewInstance(&error);
                if (error == SFERR_NO_ERROR) {
                    _editbox->SetParent(_window);                 // EBhEeɂ@@
                    _editbox->SetText("Edit Box");                // l "Edit Box" ɐݒ肷
                    _editbox->SetRealBound(rect_base);            // ̈ݒ肷
                    _editbox->SetState(true,true,true,true);      // Ԃ܂Ƃ߂āu{{\{tH[JXvɂ

                    SFXRectangle rect_button = rect_base.AddY(h); // {^zu`̈
                    // {^𐶐
                    _button = SFZTextButtonControl::NewInstance(&error);
                    if (error == SFERR_NO_ERROR) {
                        _button->SetParent(_window);  // EBhEeɂ
                        _button->SetText("Button");   // eLXg "Button" ɐݒ肷
                        // {^ꂽƂ̃nho^
                        _button->RegisterHandler(SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END), XANDLER_INTERNAL(OnButtonControl));
                        _button->SetRealBound(rect_button.Deflate(0, 20)); // ̈ݒ肷
                        _button->SetState(true, true, true, false);        // Ԃ܂Ƃ߂āu{{\{tH[JXvɂ

                        SFXRectangle rect_label = rect_base.AddY(h); // xzu`̈

                        // x𐶐
                        _label = SFZSingleTextLabelControl::NewInstance(&error);
                        if (error == SFERR_NO_ERROR) {
                            _label->SetParent(_window);                 // EBhEeɂ
                            _label->SetPropertyTransparent(false);      // ftHg͓߂Ȃ̂Ŕ񓧉߂ɂ
                            _label->SetBackgroundColor(SELAGO_COLOR);   // wiF Selago Fɂ
                            _label->SetText("Label");                   // l "Label" ɐݒ肷
                            _label->SetRealBound(rect_label);           // ̈ݒ肷
                            _label->SetState(true, true, false, false); // Ԃ܂Ƃ߂āu{{s\{tH[JXvɂ
                        }
                    }
                }
            }
        }
    }
    static_throw(error);
}

//
// fXgN^
//
textctlapp::~textctlapp(Void)
{
}

//
// {^ꂽƂ̏
//
XANDLER_IMPLEMENT_VOIDRESULT(textctlapp, OnButtonControl, invoker, result, control)
{
    unused(result);
    unused(control);
    unused(invoker);

    // GfBbg{bNX̓exɐݒ肷
    _label->SetText(_editbox->GetText());

    return;
}
