/**
***     textctlapp.hpp
***
***     ̃\[XR[h́AG[TXyhAW[Ȃǂ̏ȗĂ܂B
***     Copyright (C) 2002 - 2008 Sophia Cradle Incorporated
***     All rights reserved.
***
**/

#ifndef __TEXTCTLAPP_HPP
#define __TEXTCTLAPP_HPP

#include <SophiaFramework.hpp>
#include "textctlapp.bid"

SFMTYPEDEFCLASS(textctlapp)
class textctlapp : public SFYApplication {
    SFMSEALCOPY(textctlapp)
    private:
        SFZTitleBevelFrameSmp           _frame;
        SFZWindowSmp                    _window;
        SFZSingleEditBoxControlSmp      _editbox;
        SFZTextButtonControlSmp         _button;
        SFZSingleTextLabelControlSmp    _label;
    public:
        static SFCInvokerPtr Factory(Void);
    private:
        explicit textctlapp(Void) static_throws;
        virtual ~textctlapp(Void);
        XANDLER_DECLARE_VOIDRESULT(OnButtonControl)
};

#endif // __TEXTCTLAPP_HPP //
